<template>
  <header>
    <nav>
      <router-link to="/">Home</router-link>
      |
      <router-link to="/login">Login</router-link>
      |
      <router-link to="/songs/add">Add new Song</router-link>
    </nav>
    <!--Dorobit buttony login a logout-->
    <el-button v-if="!isLoggedIn" @click="$router.push({name: 'login'})">Log In</el-button>
    <el-button v-if="isLoggedIn" @click="logout">Logout</el-button>
  </header>
</template>

<script>
    import auth from '../controllers/requests/auth';

    export default {
        name: "vue-header",
        data() {
            return {
                isLoggedIn: false,
            }
        },
        created() {
            this.checkLogin()
        },
        mounted() {
            this.$root.$on("changedUserLogState", () => {
                this.checkLogin();
            })
        },
        methods: {
            logout() {
                auth.logout();
                this.isLoggedIn = false;
                this.$root.$emit("changedUserLogState");
                this.$notify({
                    title: 'Logged out',
                    message: 'User successfully logged out.',
                    type: "success"
                });
            },
            checkLogin() {
                auth.isLoggedIn().then(() => {
                    this.isLoggedIn = true;
                }).catch(() => {
                    this.isLoggedIn = false;
                })
            }
        }
    }
</script>

<style scoped>

</style>
